
#include <windows.h>
#include <conio.h>

#include "vflash.h"

void microDelay( unsigned long ms )
{
    // we need some sleep, that is faster than a Millisecond...
    // http://ldp.paradoxical.co.uk/HOWTO/IO-Port-Programming-4.html
	// 
    // Inputting or outputting any byte from/to port 0x80 should wait 
    // for almost exactly 1 microsecond independent of your processor
    // type and speed. You can do this multiple times to wait a few 
    // microseconds. The port output should have no harmful side effects
    // on any standard machine (and some kernel drivers use it).
	for(int i=ms;i>0;i--)
	{
		unsigned char Temp = _inp(0x80);
	}
}

static int PP_DATA=0x378;
static int PP_STATUS=0x379;
static int PP_CTRL=0x37a;

// check the OS which GIVEIO should be necessary
static int is_winnt(void)
{
	OSVERSIONINFO osvi;

	osvi.dwOSVersionInfoSize = sizeof(osvi);
	if( !GetVersionEx(&osvi) )
		return 0;

	switch (osvi.dwPlatformId)
	{
		case VER_PLATFORM_WIN32_NT:
			return 1;
		case VER_PLATFORM_WIN32_WINDOWS:
			return 0;
		case VER_PLATFORM_WIN32s:
			return 0;
	}

	/* unknown */
	return 0;
}

int pp_init(int port) 
{ 
	PP_DATA=port;
	PP_STATUS=port+1;
	PP_CTRL=port+2;
 
    if( is_winnt() ) 
	{
        // #################################################################
        //  So we are in WinNT, Win2000 or WinXP, we need to open and close
        //     the GIVEIO device. This should give us direct I/O access.  
        // #################################################################

	HANDLE h = CreateFile("\\\\.\\giveio", GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);

	if(h == INVALID_HANDLE_VALUE) 
	{
		printf(" Driver error: Could not access the GIVEIO device!\n");
		return(-1);
	}

	CloseHandle(h);
	}
	return 0; 

}